

//
//  ChannelWidget.hpp
//  e_bash
//
//  Created by Arnaud Blanchard on 29/09/2019.
//

#ifndef ChannelWidget_hpp
#define ChannelWidget_hpp

#include <gtkmm.h>
#include <string>
#include "blc_channel.h"
#include "ChannelColumns.hpp"
#include "ContextMenu.hpp"
#include "Command.hpp"
#include <unordered_map>
#include <map>


struct ChannelWidget:Gtk::TreeView{
    std::map<int, blc_channel> channels;
    ContextMenu *menu=nullptr;
    Gtk::CellRendererPixbuf  terminal_cell_renderer, play_pause_cell_renderer, stop_cell_renderer;
    Glib::RefPtr<Gtk::TreeStore>  tree_store;
    std::string bin_dir;
    std::vector<Command> used_commands;
    
    std::vector<Gtk::TreeRow> channel_rows;
    
    static std::map<std::string, Command> default_commands;
    static ChannelColumns columns;

    ChannelWidget();
    blc_channel *find_channel(int  id);
    ContextMenu *create_popup_menu();
    void create_and_execute_command(std::string program_name, std::initializer_list<const char*> const optional_arguments);

    void display_process(Gtk::TreeModel::Row &row);
    void refresh_channel_list();
    void after_launch(Process *process, std::vector<Gtk::TreeModel::Path> rows);
    void on_quit(Process *process, int status, std::vector<Gtk::TreeModel::Path> rows);

};
#endif /* Channel_hpp */
