//
//  Command.cpp
//  gtk_channels
//
//  Created by Arnaud Blanchard on 21/10/2019.
//
#include "Command.hpp"
#include <numeric> //accumulate
using namespace std;

Command::Command(string const &bin_dir, string program_name, initializer_list<char const*> default_args, function<bool(vector<blc_channel const*>)>valid_channels):binary(bin_dir+"/"+program_name), program_name(move(program_name)), valid_channels(valid_channels){
    args.emplace_back(binary.data());
    args.insert(args.end(), default_args);
}

Command::Command(Command const &command, vector<blc_channel const*> const channels){
    *this=command;
    args.reserve(args.size()+channels.size()+1);
    for (auto const &channel:channels){
        args.emplace_back(channel->name);
    }
    args.emplace_back(nullptr);
}

void Command::add_args(initializer_list<char const *> optional_args){
    args.insert(args.end(), optional_args);
}

unique_ptr<Process> Command::execute(function<void(Process*)> after_launch) const{
    
  /*  for (auto &channel:channels){
        process_args.emplace_back(channel->name);
    }*/
}
