#include "Histogram.hpp"
#include <vector>

using namespace std;


Histogram::Histogram(blc_array const &array):blc_array(array){
    pointer_info.resize(64);
    widget=gtk_box_new(GTK_ORIENTATION_VERTICAL, 1);
    GdkDisplay* default_display = gdk_display_get_default();
    GdkSeat* seat = gdk_display_get_default_seat(default_display);
    pointer_device = gdk_seat_get_pointer(seat);
    window=gtk_widget_get_window(widget);
    
    image=gtk_image_new_from_surface(surface);
    scrolled_window=gtk_scrolled_window_new(nullptr, nullptr);
    legend_box=gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 1);
    gtk_container_add(GTK_CONTAINER(scrolled_window), image);
    g_signal_connect(G_OBJECT(scrolled_window), "size-allocate", G_CALLBACK(resize_cb), this);
}

bool Histogram::get_pointer_position(int &i){
    int j, x,y;
    gdk_window_get_device_position(window, pointer_device, &x, &y, nullptr);
    i=x*x_scale;
    j=y*y_scale;
    return (i>=0 && i<256 && j>=0 && j<256);
}

// static
void Histogram::resize_cb(GtkWidget *widget, GdkRectangle *allocation, Histogram *histogram){
    
    cairo_surface_set_device_scale(histogram->surface, (double)256/(double)allocation->width, (double)256/(double)allocation->height);
}
